#include <avr/io.h>
#include <avr/delay.h>
#include <ds18b20.h>
char digits[3]={10,10,10};
char dot;
char sign;
char current_segment;
int temp;
char fractions;
void step(){
char segments[12]={1+2+8+32+128+64,32+8,128+32+16+1+2,128+32+16+8+2,64+16+32+8,64+16+8+2+128,128+64+1+2+8+16,128+32+8,255-4,255-5,16,0};
PORTA=255;PORTB=0;DDRB=255;
if(current_segment==128){current_segment=1;}else{current_segment*=2;};
if((current_segment==4)&&(dot==1))PORTB+=4;
if((segments[digits[0]]&current_segment)!=0)DDRB-=1;
if((segments[digits[1]]&current_segment)!=0)PORTB+=4;
if((segments[digits[2]]&current_segment)!=0)PORTB+=2;
PORTA=255-current_segment;
_delay_ms(2);
};
void request(){
ds18b20_reset(); //reset
ds18b20_writebyte(DS18B20_CMD_SKIPROM); //skip ROM
ds18b20_writebyte(DS18B20_CMD_CONVERTTEMP); //start temperature conversion
}
void measure(){
char templow,temphigh;

ds18b20_reset(); //reset
ds18b20_writebyte(DS18B20_CMD_SKIPROM); //skip ROM
ds18b20_writebyte(DS18B20_CMD_RSCRATCHPAD); //read scratchpad
sign=0;
templow = ds18b20_readbyte();
temphigh =ds18b20_readbyte();
temphigh&=15;
temp=1;
if(temphigh>=8){sign=1;temphigh=~temphigh;templow=~templow;
templow+=1;if(templow==0)temphigh+=1;
temp=-1;
};
fractions=templow&15;
temp*=((temphigh<<4)&112)+((templow>>4)&31);//+fractions;
//if(err!=0)temp=999;
};
void convert(){
char fr[16]={0,1,1,2,3,3,4,4,5,6,6,7,8,8,9,9};
if((temp>=0)&&(sign==0)){
if(temp<10){
digits[0]=11;
digits[1]=temp%10;
digits[2]=fr[fractions];
dot=1;
};
if((temp>=10)&&(temp<100)){
digits[0]=(temp/10)%10;;
digits[1]=temp%10;
digits[2]=fr[fractions];
dot=1;
};
if(temp>=100){
digits[0]=(temp/100)%10;
digits[1]=(temp/10)%10;
digits[2]=temp%10;
dot=0;
};
}else{
if(temp>-10){
digits[0]=10;
digits[1]=(-temp)%10;
digits[2]=fr[fractions];
dot=1;
};
if(temp<=-10){
digits[0]=10;
digits[1]=((-temp)/10)%10;
digits[2]=(-temp)%10;
dot=0;
};

}
/*digits[2]=digits[1];
digits[1]=digits[0];
digits[0]=0;*/
}

void main(){
DDRA=255;PORTA=255;
//for(;;)	{PORTA=0;_delay_ms(1);PORTA=128;_delay_ms(1);};
DDRB=254;
current_segment=1;
dot=0;
long int j;
request();//_delay_ms(1000);measure();convert();
for(;;){
//DDRB=255;
for(j=0;j<500;++j)step();PORTA=255;DDRB=254;_delay_ms(1);measure();convert();
//DDRB=255;
for(j=0;j<500;++j)step();PORTA=255;DDRB=254;_delay_ms(1);request();
//request();_delay_ms(1000);measure();convert();
}

}